#include  "ref_count_ptr.h"

#if 0
int    main( void )
{
	ref_count_ptr<int>		ptr( new int(1) );
	ref_count_ptr<const int>	const_ptr( ptr );
}
#endif


#if 0
int    main( void )
{
	ref_count_ptr<int>		ptr( new int(1) );
	ref_count_ptr<const int>	const_ptr( new int(2) );

	const_ptr = ptr;
}
#endif


#if 0
class B
{
};

class D : public B
{
};

int    main( void )
{
	ref_count_ptr<D>	d( new D );
	ref_count_ptr<B>	b( d );
}
#endif

#if 0
#include  <iostream>

class B
{
public:
	virtual	~B() {}
	virtual	void	print() { std::cout << "B" << std::endl; }
};

class D : public B
{
public:
	virtual	void	print() { std::cout << "D" << std::endl; }
};

int    main( void )
{
	ref_count_ptr<D>	d( new D );
	ref_count_ptr<B>	b( d );

	b.type_check<D>();
}
#endif

#if 0
void   func( const ref_count_ptr<const int> )
{
}

void   func( const ref_count_ptr<double> )
{
}

int    main( void )
{
	ref_count_ptr<int>		ptr( new int(1) );
	ref_count_ptr<const int>	const_ptr( new int(2) );

	func( const_ptr );
#if 0
	func( ptr );
#endif
}
#endif


#if 0
class B
{
};

class D : public B
{
};

int    main( void )
{
	ref_count_ptr<B>	b( new D );

#if 0
	ref_count_ptr<D>	d = b;
#endif
}
#endif


#if 0
#include  "heap_status.h"
#include  <cstdlib>
#include  <cstdio>
#include  <iostream>

using namespace std;

static
void   report_new_delete()
{
	Heap_Status::report();
}

int    main( void )
{
	if ( atexit( report_new_delete ) == -1 )
	{
		perror( "atexit" );
	}

	ref_count_ptr<int>	p1;
	ref_count_ptr<int>	p2;
	ref_count_ptr<int>	p3;

	p1 = new int;
	*p1 = 1;

	p2 = p1;
	p3 = p2;

	cout << *p3 << endl;

	return( 0 );
}
#endif


#if 0
#include  "heap_status.h"
#include  <cstdlib>
#include  <cstdio>
#include  <iostream>

using namespace std;

static
void   report_new_delete()
{
	Heap_Status::report();
}

int    main( void )
{
	if ( atexit( report_new_delete ) == -1 )
	{
		perror( "atexit" );
	}

	ref_count_ptr< ref_count_ptr<int> >	p1;
	ref_count_ptr< ref_count_ptr<int> >	p2;

	p1 = new ref_count_ptr<int>;

	*p1 = new int;
	p2 = p1;

	**p2 = 1;

	cout << **p2 << endl;

	return( 0 );
}
#endif


#if 0
#include  "heap_status.h"
#include  <cstdlib>
#include  <cstdio>
#include  <iostream>

using namespace std;

static
void   report_new_delete()
{
	Heap_Status::report();
}

int    main( void )
{
	if ( atexit( report_new_delete ) == -1 )
	{
		perror( "atexit" );
	}

	ref_count_ptr<int>	p1;

	p1 = new int;
	*p1 = 1;

	p1 = p1;

	cout << *p1 << endl;

	return( 0 );
}
#endif


#if 0
#include  "heap_status.h"
#include  <cstdlib>
#include  <cstdio>
#include  <iostream>

using namespace std;

static
void   report_new_delete()
{
	Heap_Status::report();
}

class	A
{
public:
	void	print()
		{
			cout << "A" << endl;
		}
};

int    main( void )
{
	if ( atexit( report_new_delete ) == -1 )
	{
		perror( "atexit" );
	}

	ref_count_ptr<A>	a( new A );

	a -> print();

	return( 0 );
}
#endif


#if 0
#include  <memory>

int    main( void )
{
#if 1
	ref_count_ptr<int>	a( new int(3) );
#elif 0
	auto_ptr<int>		a( new int(3) );
#else
	int *			a( new int(3) );
#endif

	for ( int  i = 0  ;  i < 10 * 1000 * 1000  ;  i ++ )
	{
		*a = 1;
	}
}
#endif


#if 0
#include  <memory>

int    main( void )
{
	for ( int  i = 0  ;  i < 10 * 1000 * 1000  ;  i ++ )
	{
#if 1
		ref_count_ptr<int>	a( new int(3) );
#elif 0
		auto_ptr<int>		a( new int(3) );
#else
		int *			a( new int(3) );
#endif

		*a = 1;
	}
}
#endif


#if 0
int    main( void )
{
	ref_count_ptr<int>		ptr( new int(1) );

	if ( ! static_cast<bool>(ptr) )
	{
		return( 1 );
	}

	if ( ptr == 0 )
	{
		return( 1 );
	}

	if ( ! (ptr != 0) )
	{
		return( 1 );
	}

	if ( ptr == static_cast<int *>(0) )
	{
		return( 1 );
	}

	if ( ! (ptr != static_cast<int *>(0)) )
	{
		return( 1 );
	}

	if ( ptr == static_cast<void *>(0) )
	{
		return( 1 );
	}

	if ( ! (ptr != static_cast<void *>(0)) )
	{
		return( 1 );
	}
}
#endif


#if 0
#include  <memory>

int    main( void )
{
	for ( int  i = 0  ;  i < 10 * 1000 * 1000  ;  i ++ )
	{
#if 1
		ref_count_ptr<int>	a( new int(3) );
		ref_count_ptr<int>	b;
#elif 0
		auto_ptr<int>		a( new int(3) );
		auto_ptr<int>		b;
#else
		int *			a( new int(3) );
		int *			b;
#endif

		*a = 1;

		b = a;
	}
}
#endif

#if 0
int    main( void )
{
	ref_count_ptr<int>	i( new int );

	i = i;
	i = i;
	i = i;
}
#endif

#if 0
#include  <set>
#include  "test_environment.h"

int    main( void )
{
	Test_Environment	t;

	ref_count_ptr<int>	a = new int(1);
	ref_count_ptr<int>	b = new int(2);

	std::set< ref_count_ptr<int> >	s;

	s.insert( a );
	t.Assert_Equals( static_cast<size_t>(1) , s.size() );
	t.Assert_Not_Equals( s.end() , s.find( a ) );
	t.Assert_Equals( s.end() , s.find( b ) );

	s.insert( b );
	s.insert( ref_count_ptr<int>() );
	t.Assert_Equals( 3 , s.size() );

	return( t.exit_status() );
}
#endif

#if 0
#include  "ref_count_array_ptr.h"

int    main( void )
{
	ref_count_array_ptr<char>	buf = new char[10];
	ref_count_ptr<char>		ch = buf; // expect error
}
#endif

#if 1
#include  <set>
#include  "test_environment.h"

class  A
{
public:
	int	n_destractor_called;

public:
	A() : n_destractor_called( 0 )
	{
	}

	~A()
	{
		n_destractor_called ++;
	}
};


int    main( void )
{
	Test_Environment	t;

	//
	// test operator ==, !=
	//
	{
		ref_count_ptr<A>	a = new A;
		ref_count_ptr<A>	b = new A;

		t.Assert_Equals( a , a );
		t.Assert_Not_Equals( a , b );

		t.Assert_Equals( a.get() , a.get() );
		t.Assert_Not_Equals( a.get() , b.get() );
	}


	//
	// test operator ==, !=
	//
	{
		ref_count_ptr<A *>	a = new A *;
		ref_count_ptr<A *>	b = new A *;

		t.Assert_Equals( a , a );
		t.Assert_Not_Equals( a , b );

		t.Assert_Equals( a.get() , a.get() );
		t.Assert_Not_Equals( a.get() , b.get() );
	}


	//
	// test set
	//
	{
		ref_count_ptr<A>	a = new A;
		ref_count_ptr<A>	b = new A;

		std::set< ref_count_ptr<A> >	s;

		s.insert( a );
		t.Assert_Equals( static_cast<size_t>(1) , s.size() );
		t.Assert_Not_Equals( s.end() , s.find( a ) );
		t.Assert_Equals( s.end() , s.find( b ) );

		s.insert( b );
		t.Assert_Not_Equals( s.end() , s.find( b ) );
		s.insert( ref_count_ptr<A>() );
		t.Assert_Equals( static_cast<size_t>(3) , s.size() );

		t.Assert_Equals( 0 , a -> n_destractor_called );
	}


	return( t.exit_status() );
}
#endif
